<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/model/bd/Bi_usuario_grupoDAO.php");
$bi_usuario_grupoDAO = new Bi_usuario_grupoDAO();
require_once($config->diretorio_raiz()."/src/model/bd/Bi_usuarioDAO.php");
$bi_usuarioDAO = new Bi_usuarioDAO(); 
require_once($config->diretorio_raiz()."/src/model/bd/Bi_grupo_permissaoDAO.php");
$bi_grupo_permissaoDAO = new Bi_grupo_permissaoDAO(); 
$retorno = array();
if (isset($_GET["mod"]) && $_GET["mod"] == "form")
{
	if ( (isset($_GET["codigo"]) and $_GET["codigo"] != "")  )
	{
		$bi_usuario_grupo = $bi_usuario_grupoDAO->buscarBi_usuario_grupo($_GET["codigo"]);
	}else{
		$bi_usuario_grupo = new Bi_usuario_grupo();
		$bi_usuario_grupo->setUsuario(new Bi_usuario());
		$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
	}
	$listaUsuario = $bi_usuarioDAO->listarTodosRegistros(); 
	$listaGrupo = $bi_grupo_permissaoDAO->listarTodosRegistros(); 
	if (isset($_GET["usuario"]) and $_GET["usuario"] != "")
	{
		$bi_usuario_grupo->setUsuario($bi_usuarioDAO->buscarBi_usuario($_GET["usuario"]));
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if (isset($_GET["grupo"]) and $_GET["grupo"] != "")
	{
		$bi_usuario_grupo->setGrupo($bi_grupo_permissaoDAO->buscarBi_grupo_permissao($_GET["grupo"]));
		$campo_buscar = "&grupo=".$_GET["grupo"]; 
	}
	include_once($config->diretorio_raiz()."/src/view/bi_usuario_grupo/Formulario.php");
}
elseif (isset($_GET["mod"]) && ($_GET["mod"] == "salvar" or $_GET["mod"] == "alterar"))
{
	$bi_usuario_grupo = new Bi_usuario_grupo();
	$bi_usuario_grupo->setCodigo($_POST['codigo']);
	$bi_usuario_grupo->setUsuario($_POST['usuario']);
	$bi_usuario_grupo->setGrupo($_POST['grupo']);
	$codigo = "";
	if ($_GET["mod"] == "alterar")
	{
		$bi_usuario_grupo->setCodigo($_POST['codigo']);
		$codigo = $bi_usuario_grupo->getCodigo();
		try
		{
			$retorno["mensagem"] = "Alterado com sucesso!";
			$retorno["status"] = true;
			$bi_usuario_grupoDAO->atualizar($bi_usuario_grupo);
		}
		catch (Exception  $e)
		{
			$retorno["mensagem"] = $e->getMessage();
			$retorno["status"] = false;
		}
	}
	else
	{
		try
		{
			$retorno["mensagem"] = "Inserido com sucesso!";
			$retorno["status"] = true;
			$codigo = $bi_usuario_grupoDAO->salvar($bi_usuario_grupo);
		}
		catch (Exception  $e)
		{
			$retorno["mensagem"] = $e->getMessage();
			$retorno["status"] = false;
		}
	}
	echo json_encode($retorno);
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "excluir")
{
	try
	{
		$bi_usuario_grupo = $bi_usuario_grupoDAO->buscarBi_usuario_grupo($_GET["codigo"]);
		$bi_usuario_grupoDAO->excluir($bi_usuario_grupo);
		$retorno["mensagem"] = utf8_decode("Excluido com sucesso!");
		$retorno["status"] = true;
	}
	catch (Exception  $e)
	{
		$retorno["mensagem"] = $e->getMessage();
		$retorno["status"] = false;
	}
	echo json_encode($retorno);
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "listar")
{
	if (isset($_GET["usuario"]) and $_GET["usuario"] != "")
	{
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if (isset($_GET["grupo"]) and $_GET["grupo"] != "")
	{
		$campo_buscar = "&grupo=".$_GET["grupo"]; 
	}
	$listaBi_usuario_grupo = $bi_usuario_grupoDAO->listarTodosRegistros();
	include_once($config->diretorio_raiz()."/src/view/bi_usuario_grupo/Listar_todos_registros.php");
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "filtro")
{
	if ( (isset($_GET["codigo"]) and $_GET["codigo"] != "")  )
	{
		$bi_usuario_grupo = $bi_usuario_grupoDAO->buscarBi_usuario_grupo($_GET["codigo"]);
	}else{
		$bi_usuario_grupo = new Bi_usuario_grupo();
		$bi_usuario_grupo->setUsuario(new Bi_usuario());
		$bi_usuario_grupo->setGrupo(new Bi_grupo_permissao());
	}
	$listaUsuario = $bi_usuarioDAO->listarTodosRegistros(); 
	$listaGrupo = $bi_grupo_permissaoDAO->listarTodosRegistros(); 
	if (isset($_GET["usuario"]) and $_GET["usuario"] != "")
	{
		$bi_usuario_grupo->setUsuario($bi_usuarioDAO->buscarBi_usuario($_GET["usuario"]));
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if (isset($_GET["grupo"]) and $_GET["grupo"] != "")
	{
		$bi_usuario_grupo->setGrupo($bi_grupo_permissaoDAO->buscarBi_grupo_permissao($_GET["grupo"]));
		$campo_buscar = "&grupo=".$_GET["grupo"]; 
	}
	include_once($config->diretorio_raiz()."/src/view/bi_usuario_grupo/Filtro_lista_registros.php");
}
elseif (isset($_GET["mod"]) && $_GET["mod"] == "busca_por_campo_filtro")
{
	$entrouEmAlgumFiltro = false;
 	$where = " where 1=1";
	if(isset($_GET['codigo']) and $_GET["codigo"] != "" )
	{
		$where .= " and UPPER(codigo) like '%".strtoupper($_GET['codigo'])."%'";
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&codigo=".$_GET["codigo"]; 
	}
	if(isset($_POST['codigo']) and $_POST["codigo"] != "" )
	{
		$where .= " and UPPER(codigo) like '%".strtoupper($_POST['codigo'])."%'";
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&codigo=".$_POST["codigo"]; 
	}
	if(isset($_GET['usuario']) and $_GET['usuario'] != "")
	{
		$where .= " and usuario = ". $_GET['usuario'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&usuario=".$_GET["usuario"]; 
	}
	if(isset($_POST['usuario']) and $_POST['usuario'] != "")
	{
		$where .= " and usuario = ". $_POST['usuario'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&usuario=".$_POST["usuario"]; 
	}
	if(isset($_GET['grupo']) and $_GET['grupo'] != "")
	{
		$where .= " and grupo = ". $_GET['grupo'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&grupo=".$_GET["grupo"]; 
	}
	if(isset($_POST['grupo']) and $_POST['grupo'] != "")
	{
		$where .= " and grupo = ". $_POST['grupo'];
		$entrouEmAlgumFiltro = true;
		$campo_buscar = "&grupo=".$_POST["grupo"]; 
	}
	$listaBi_usuario_grupo = $bi_usuario_grupoDAO->buscarFiltro($where);
	include_once($config->diretorio_raiz()."/src/view/bi_usuario_grupo/Listar_todos_registros.php");
}
